//
// "$Id: fl_color_win32.cxx,v 1.14.2.3.2.4 2002/05/16 02:16:17 easysw Exp $"
//
// WIN32 color functions for the Fast Light Tool Kit (FLTK).
//
// Copyright 1998-2002 by Bill Spitzak and others.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
//
// Please report all bugs and problems to "fltk-bugs@fltk.org".
//

// The fltk "colormap".  This allows ui colors to be stored in 8-bit
// locations, and provides a level of indirection so that global color
// changes can be made.  Not to be confused with the X colormap, which
// I try to hide completely.

// SGI compiler seems to have problems with unsigned char arguments
// being used to index arrays.  So I always copy them to an integer
// before use.

#include <config.h>
#include <FL/Fl.H>
//#include <FL/win32.H>
#include <FL/fl_draw.H>

#include <Fl/Fl_Output_Device.H>
#define fl_color Fl_Output_Device::color

#include "fl_color_win32_dev.cxx"

//void _fl_clear_xmap(Fl_XMap& xmap){clear_xmap(xmap);};

/*
struct Fl_Gdi_State{
    HPEN tmppen;
    HBRUSH tmpbrush;
    HPEN savepen;
    Fl_Brush brushes[FL_N_BRUSH];
    Fl_XMap fl_xmap[256];
    Fl_Xmap xmap;
};
*/


static HPEN tmppen_save;
static HBRUSH tmpbrush_save;
static HPEN savepen_save;
static Fl_Brush *brushes_save;
static Fl_XMap *fl_xmap_save;
static Fl_XMap xmap_save;
static Fl_Region r_save;

FL_EXPORT HDC fl_gc_save = 0;
    
extern Fl_Region fl_clip_region();

FL_EXPORT void push_xmaps(){
  r_save = fl_clip_region();
  tmppen_save = tmppen;
  tmpbrush_save = tmpbrush;
  savepen_save = savepen;
  brushes_save = brushes;
  fl_xmap_save = fl_xmap;
  fl_gc_save = fl_gc;
 
};



FL_EXPORT void set_xmaps(HPEN tmppen_, HBRUSH tmpbrush_, HPEN savepen_, Fl_Brush *brushes_, Fl_XMap * fl_xmap_, Fl_XMap xmap_){

  tmppen = tmppen_;
  tmpbrush= tmpbrush_;
  savepen = savepen_;
  brushes = brushes_;
  fl_xmap = fl_xmap_;

  
};

FL_EXPORT void pop_xmaps(){
  if(!fl_gc_save) return;
  fl_gc = fl_gc_save;
  tmppen = tmppen_save;
  tmpbrush = tmpbrush_save;
  savepen = savepen_save;
  brushes = brushes_save;
  fl_xmap = fl_xmap_save;
  fl_clip_region(r_save);
}


  
  
  


