//
// "$Id: fl_rect.cxx,v 1.10.2.4.2.8 2002/03/06 18:11:01 easysw Exp $"
//
// Rectangle drawing routines for the Fast Light Tool Kit (FLTK).
//
// Copyright 1998-2002 by Bill Spitzak and others.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
//
// Please report all bugs and problems to "fltk-bugs@fltk.org".
//

// These routines from fl_draw.H are used by the standard boxtypes
// and thus are always linked into an fltk program.
// Also all fl_clip routines, since they are always linked in so
// that minimal update works.

#include <FL/Fl_Widget.H>
#include <FL/fl_draw.H>
#include <FL/x.H>


#include <FL/Fl_Output_Device.H>


#define fl_push_clip	Fl_Output_Device::push_clip
#define fl_push_no_clip	Fl_Output_Device::push_no_clip
#define fl_pop_clip	Fl_Output_Device::pop_clip
#define fl_not_clipped	Fl_Output_Device::not_clipped
#define fl_clip_box	Fl_Output_Device::clip_box
#define fl_point Fl_Output_Device::point
#define fl_rect Fl_Output_Device::rect
#define fl_line Fl_Output_Device::line
#define fl_loop Fl_Output_Device::loop
#define fl_polygon Fl_Output_Device::polygon
#define fl_rectf Fl_Output_Device::rectf
#define fl_xyline Fl_Output_Device::xyline
#define fl_yxline Fl_Output_Device::yxline

/*
// Clipping is relative to device coordinates, work arround needs to be done
#ifdef WIN32

void fl_SelectClipRgn(HDC dc, HRGN r);
BOOL fl_RectInRegion(HRGN, CONST RECT *);

struct Fl_Ext{
	int WOx, VEx, WEx, VOx;
	int WOy, VEy, WEy, VOy;
};

Fl_Ext * fl_ext = 0;

#define SelectClipRgn fl_SelectClipRgn
#define RectInRegion fl_RectInRegion

#endif

*/

#include "fl_rect_generic.cxx"



#ifdef WIN32

Fl_Region * fl_clip_stack = rstack;
int * fl_clip_stack_pointer = & rstackptr;

#endif
/*
#undef SelectClipRgn
#undef RectInRegion

void fl_SelectClipRgn(HDC dc, HRGN r) {
	if(!r){
		SelectClipRgn(dc, r);
		return;
	}
	if(fl_ext){
	  RECT rect;
	  GetRgnBox(r,&rect);
	  //rect.left = ((rect.left - fl_ext->WOx) * fl_ext->VEx - fl_ext->VEx/2)/ fl_ext->WEx + fl_ext->VOx;
	  //rect.right = ((rect.right - fl_ext->WOx) * fl_ext->VEx - fl_ext->VEx /2)/ fl_ext->WEx + fl_ext->VOx;
	  //rect.top = ((rect.top - fl_ext->WOy) * fl_ext->VEy - fl_ext->VEy/2) / fl_ext->WEy + fl_ext->VOy;
	  //rect.bottom = ((rect.bottom - fl_ext->WOy) * fl_ext->VEy - fl_ext->VEy/2)/ fl_ext->WEy + fl_ext->VOy;
	  //SelectClipRgn(dc,0);
	  BeginPath(dc);
	  MoveToEx(dc, rect.left,rect.bottom,0);
	  LineTo(dc,rect.right,rect.bottom);
	  LineTo(dc,rect.right,rect.top);
	  LineTo(dc,rect.left,rect.top);
	  CloseFigure(dc);
	  EndPath(dc);
	  SelectClipPath(dc,RGN_COPY);
	}else
	  SelectClipRgn(dc, r);
}

BOOL fl_RectInRegion(HRGN r, CONST RECT *rect){
	if(fl_ext){
		RECT rectangle;
		rectangle.left = ((rect->left - fl_ext->WOx) * fl_ext->VEx - fl_ext->VEx/2)/ fl_ext->WEx + fl_ext->VOx;
		rectangle.right = ((rect->right - fl_ext->WOx) * fl_ext->VEx - fl_ext->VEx /2)/ fl_ext->WEx + fl_ext->VOx;
		rectangle.top = ((rect->top - fl_ext->WOy) * fl_ext->VEy - fl_ext->VEy/2) / fl_ext->WEy + fl_ext->VOy;
		rectangle.bottom = ((rect->bottom - fl_ext->WOy) * fl_ext->VEy - fl_ext->VEy/2)/ fl_ext->WEy + fl_ext->VOy;
		return RectInRegion(r,&rectangle);
	}else
		return RectInRegion(r,rect);
}


#endif

*/
